require 'test_helper'

class ViewOperationsTest < ActiveSupport::TestCase

  def test_create_view
    # Look at Dummy for app, Model, migration, etc ...
    
    Person.create(:first_name => 'John', :last_name => 'Doe', :ssn => '123456789')
    
    assert_nothing_raised do
      # I DONT UNDERSTANT the "do" : xxx.create_view() do ?
      # create_view return a empty array 
      ActiveRecord::Base.connection.create_view(:v_people,
         #  'select first_name, last_name, ssn from people', :force => true) do |v|
        'select  id, first_name, last_name, ssn from people', :force => true) do |v|
        v.column :id  # ID est obligatoire ?
        v.column :f_name
        v.column :l_name
        v.column :social_security
      end
    end
    # p = Person.find(:first) # rails 3
    p = Person.first
    # vp = VPerson.find(:first)
    vp = VPerson.first
    # assert_equal p.first_name, vp.f_name
    assert_equal p.first_name, vp.first_name
  end
  
  def test_drop_view
    assert_nothing_raised do
      ActiveRecord::Base.connection.create_view(:v_place,
          'select address, city, cstate, country from places', :force => true) do |v|
        v.column :v_address
        v.column :v_city
        v.column :v_state
        v.column :v_country
      end
      ActiveRecord::Base.connection.drop_view(:v_place)
    end
    assert_raises(ActiveRecord::StatementInvalid) do
      ActiveRecord::Base.connection.execute "SELECT * FROM v_place"
    end
  end
  
  def test_create_or_replace_view
    # Look at Dummy for app, Model, migration, etc ...
    
    Person.create(:first_name => 'John', :last_name => 'Doe', :ssn => '123456789')
    
    assert_nothing_raised do
       ActiveRecord::Base.connection.create_view(:v_people,
           #  'select first_name, last_name, ssn from people', :force => true) do |v|
          'select  id from people', :force => true) do |v|
          v.column :id  # ID est obligatoire ?
        end
      # I DONT UNDERSTANT the "do" : xxx.create_view() do ?
      # create_view return a empty array 
      ActiveRecord::Base.connection.create_or_replace_view(:v_people,
         #  'select first_name, last_name, ssn from people', :force => true) do |v|
        'select  id, first_name, last_name, ssn from people', :force => true) do |v|
        v.column :id  # ID est obligatoire ?
        v.column :f_name
        v.column :l_name
        v.column :social_security
      end
    end
    # p = Person.find(:first) # rails 3
    p = Person.first
    # vp = VPerson.find(:first)
    vp = VPerson.first
    # assert_equal p.first_name, vp.f_name
    assert_equal p.first_name, vp.first_name
  end
  
  # TODO
  def test_no_view_raises_error
    assert_raises(RuntimeError) { ActiveRecord::Base.connection.view_select_statement('foo') }
 end
end
